// tmtlib.narod.ru
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,softrender;

type
  TForm1 = class(TForm)
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

var t1,t2,t3:dword;

implementation

{$R *.dfm}


procedure MainLoop;
var i,j,k,m:integer;
var r,g,b,a:byte;
var k1{,k2}:integer;
var x,y:single;


var dx:integer;
var u,v,z:integer;
var du,dv,dz:integer;
var z0:integer;

var tu,tv:integer;

var pixelshader:cardinal;
var cnt:integer;
begin




 repeat

  fillchar(FrameBuffer^,ww*hh*4,0);
  fillchar(DepthBuffer^,ww*hh*4,$FF);

 cnt:=0; // counter for coloring shader
 for m := 0 to 100 - 1 do
 begin



  for j :=0 to hh - 1 do
   begin
     Scanlines[j]._x1:= High(Integer);
     Scanlines[j]._x2:= Low(Integer);
   end;


proj3dto2d(500+100*sin(m*123+gettickcount/1000),500-m*50,20+m+10*sin(123*m+gettickcount/1000),
           5,
           _p[0].x,_p[0].y);
_p[0].u:=255;
_p[0].v:=255;

proj3dto2d(-500,500-m*50,20+m,
           5,
           _p[1].x,_p[1].y);
_p[1].u:=0;
_p[1].v:=255;

proj3dto2d(0,0-m*50,20+m,
           5,
           _p[2].x,_p[2].y);
_p[2].u:=0;
_p[2].v:=0;

// 4 bits
_p[0].z:=round(  (20+m+10*sin(123*m+gettickcount/1000))*16 ); //round(16* (30+10*sin(gettickcount/1000)) );
_p[1].z:=(20+m)*16;
_p[2].z:=(20+m)*16;



   for i := 0 to 2 do
    if _p[i].z>0 then
     begin
//      _p[i].z:=_p[i].z shl 6;
      _p[i].z:=(1 shl wide2) div (_p[i].z);
      _p[i].u:=_p[i].u*_p[i].z;
      _p[i].v:=_p[i].v*_p[i].z;
      _p[i].x:=_p[i].x shl wide1; //16bit
     end else _p[i].z:=0;



DrawLine(0,1);
DrawLine(1,2);
DrawLine(2,0);





        


   for j := 0 to hh - 1 do
    begin
//    if Scanlines[j]._x2>ww-1 then showmessage(inttostr( Scanlines[j]._x2));


      k1:=j*ww+Scanlines[j]._x1;
      ptr_screen_pixel:=pointer(FrameBuffer);
      inc(ptr_screen_pixel,k1);

      ptr_screen_depth:=pointer(DepthBuffer);
      inc(ptr_screen_depth,k1);


      u:=(Scanlines[j]._u1);
      v:=(Scanlines[j]._v1);
      z:=(Scanlines[j]._z1);

      dx:=Scanlines[j]._x2-Scanlines[j]._x1+1; // +1?
      if dx<=0 then continue;
      if Scanlines[j]._x2<0 then continue;


      du:=((Scanlines[j]._u2-Scanlines[j]._u1)) div dx;
      dv:=((Scanlines[j]._v2-Scanlines[j]._v1)) div dx;
      dz:=((Scanlines[j]._z2-Scanlines[j]._z1)) div dx;



      for i := 0 to dx - 1 do
       begin

        z0:=z_lookup[z]; // lookup z0=1/z
      // z0:=1;
        tu:=(z0*u) shr wide2;
        tv:=(z0*v) shr wide2;


        if tu<0 then tu:=0;
        if tv<0 then tv:=0;

        if tu>255 then tu:=255;
        if tv>255 then tv:=255;


        // z-test
        if z0<ptr_screen_depth^ then
         begin
          ptr_texture_pixel:=pointer(Textures[0].FrameBuffer);
          inc(ptr_texture_pixel,Textures[0].width*tv+tu);
          ptr_screen_pixel^:=ptr_texture_pixel^;
          ptr_screen_depth^:=z0;

          case cnt of
           0:pixelshader:=$00FFFFFF;
           1:pixelshader:=$00FF0000;
           2:pixelshader:=$0000FF00;
           3:pixelshader:=$000000FF;
          end;

          
          
          ptr_screen_pixel^:=ptr_screen_pixel^ and pixelshader;


         // if i=0 then       ptr_screen_pixel^:=rgb(0,m,0);
          
         end;








        u:=u+du;
        v:=v+dv;
        z:=z+dz;

        inc(ptr_screen_pixel,1);
        inc(ptr_screen_depth,1);

       end;

    end;

                         inc(cnt);
          if cnt>3 then cnt:=0;


        end;

                 {

   for j := 0 to hh - 1 do
    begin
      for i := 0 to ww - 1 do
       begin
        ptr_screen_pixel:=pointer(FrameBuffer);
        k1:=j*ww+i;
        inc(ptr_screen_pixel,k1);
        ptr_screen_pixel^:=255;
       end;
    end;
                  }

 SetDIbitstoDevice(Form1.Canvas.Handle,
                   0,
                   0,
                   ww,
                   hh,
                   0,
                   0,
                   0,
                   hh,
                   FrameBuffer,
                   BitmapInfo,
                   DIB_RGB_COLORS);

 inc(t3);
 if t3>100 then
  begin
   t3:=0;
   t2:=t1;
   t1:=gettickcount;
   t2:=t1-t2;
   if t2>0 then form1.Caption:='tmtlib.narod.ru soft render test 3 --- 100 triangles --- '+inttostr(round( 100000/t2))+' FPS';
   sleep(1);
  end;
   application.ProcessMessages;




 until application.Terminated;


end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 // hack for correct form closing
 Application.Terminate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin

loadtexture('wall.jpg');
 // show form and start main loop
 form1.Show;
 mainloop;

end;


procedure TForm1.FormResize(Sender: TObject);
begin

 // get window size
 ww:=Form1.ClientWidth;
 hh:=Form1.ClientHeight;

 // center position
 xofs:=ww div 2;
 yofs:=hh div 2;

 // allocate memory for backbuffers
 reallocmem(FrameBuffer,ww*hh*4);
 reallocmem(DepthBuffer,ww*hh*4);

 // set backbuffer size and pixel format
 ZeroMemory(@BitmapInfo, sizeof(BitmapInfo));
 BitMapInfo.bmiHeader.biSize:=SizeOf(TBitmapInfo);
 BitMapInfo.bmiHeader.biWidth:=ww;
 BitMapInfo.bmiHeader.biHeight:=hh;
 BitMapInfo.bmiHeader.biBitCount:=32;
 BitMapInfo.bmiHeader.biPlanes:=1;
 BitMapInfo.bmiHeader.biCompression:=BI_RGB;
 BitMapInfo.bmiHeader.biSizeImage:=ww*hh*4;
end;

end.

   {




   for j := 0 to hh - 1 do
    for i := Scanlines[j]._x1 to Scanlines[j]._x2 do
    begin
      k1:=j*ww+i;
      ptr_screen_pixel:=pointer(FrameBuffer);
      inc(ptr_screen_pixel,k1);
      ptr_screen_pixel^:=255;

    end;
   for j := 0 to hh - 1 do

    begin


      k1:=j*ww+Scanlines[j]._x1;
      ptr_screen_pixel:=pointer(FrameBuffer);
      inc(ptr_screen_pixel,k1);
      ptr_screen_pixel^:=65535;

      k1:=j*ww+Scanlines[j]._x2;
      ptr_screen_pixel:=pointer(FrameBuffer);
      inc(ptr_screen_pixel,k1);
      ptr_screen_pixel^:=65535;

    end;

                  }
